#!/usr/bin/perl

my($progname) = $0 =~ m"\/([^/]*)";

%operator_symbols = (
  'addition'                  => '+',
  'addition_assignment'       => '+=',
  'subtraction'               => '-',
  'subtraction_assignment'    => '-=',
  'multiplication'            => '*',
  'multiplication_assignment' => '*=',
  'division'                  => '/',
  'division_assignment'       => '/=',
  'modulus'                   => '%',
  'modulus_assignment'        => '%=',

  'left_shift'                => '<<',
  'left_shift_assignment'     => '<<=',
  'right_shift'               => '>>',
  'right_shift_assignment'    => '>>=',

  'assignment'                => '=',

  'bitwise_and'               => '&',
  'bitwise_or'                => '|',
  'bitwise_xor'               => '^',

  'less_than'                 => '<',
  'less_than_or_equal_to'     => '<=',
  'greater_than'              => '>',
  'greater_than_or_equal_to'  => '>=',
  'equal_to'                  => '==',
  'not_equal_to'              => '!=',

  'increment'                 => '++',
  'decrement'                 => '--'  
);


my $num = 0;
++$num while -e "$progname.$num.tmp";

for $file (@ARGV) {
  next unless open FILE, $file;
  open TEMP, ">$progname.$num.tmp";

  while(<FILE>) {
    s/\bsv_undef\b/PL_sv_undef/g if /\bsv_undef\b/;
    s/\bsv_yes\b/PL_sv_yes/g if /\bsv_yes\b/;
    s/\bna\b/PL_na/g if /\bna\b/;

    for $key (keys %operator_symbols) {
      s/\b$key\b/ operator$operator_symbols{$key} /
    }

    s/swig_setiv\("(?!XML::Xercesc::)/swig_setiv("XML::Xercesc::/;
    s/SWIG_GetPtr(.*?)"(?!XML::Xerces::)(\w+)"/SWIG_GetPtr$1"XML::Xerces::$2"/;
    s/SWIG_RegisterMapping\("(?!XML::Xerces::)(\w+)","(?!XML::Xerces::)(\w+)",Swig/SWIG_RegisterMapping("XML::Xerces::$1","XML::Xerces::$2",Swig/;
    s/sv_setref_pv\(ST\(argvi\+\+\),"(?!XML::Xerces::)/sv_setref_pv(ST(argvi++),"XML::Xerces::/;
    s/boot_Xerces/boot_XML__Xerces/g;

    print TEMP;
  }

  close FILE;
  close TEMP;

  rename "$progname.$num.tmp", $file;
}

